/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#if !defined(HARK_BASE_SLEEP_H_INCLUDED)
#define HARK_BASE_SLEEP_H_INCLUDED 1

#include "common.h"

#include "Node.h"

namespace HARK
{
    class Sleep : public Node
    {
    public:
	Sleep(const std::string &nodeName, const ParameterSet &params);
	
	ObjectRef getOutput(int output_id, int count);

    private:
	int getMilliCount() const;
	int getMilliSpan(int nTimeStart) const;

    private:
	int   _outputID;
	float _time;
	float _mSec;
	int   _pt;
    };
}

#endif

/* end of file */
