/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#if !defined(HARK_BASE_TYPEMAP_H_INCLUDED)
#define HARK_BASE_TYPEMAP_H_INCLUDED 1

#include "common.h"

#include <algorithm>
#include <map>
#include <typeinfo>

struct compare_const_type_info_ptr : public std::binary_function<const std::type_info *, const std::type_info *, bool> {
    bool operator()(const std::type_info *lhs, const std::type_info *rhs) const
    {
        return lhs->before(*rhs);
    }
};

template<typename T>
class TypeMap : public std::map<const std::type_info *, T, compare_const_type_info_ptr >
{
};

#endif

/* end of file */
