/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#include "NOP.h"

namespace HARK
{
    DECLARE_NODE(NOP);
    /*Node
     *
     * @name NOP
     * @category General
     * @description Pass Through (no operation)
     *
     * @input_name INPUT
     * @input_description The input
     *
     * @output_name OUTPUT
     * @output_description The output = The input
     *
     END*/

    NOP::NOP(const std::string &nodeName, const ParameterSet &params)
        : BufferedNode(nodeName, params)
    {
	this->_inputID  = this->addInput("INPUT");
	this->_outputID = this->addOutput("OUTPUT");
    }

    void
    NOP::calculate(int output_id, int count, Buffer &out)
    {
        ObjectRef input1Value = this->getInput(this->_inputID, count);
        out[count] = input1Value;
    }
}

/* end of file */

